#pragma once
#include <string>
#include <iostream>

#include "ExplosionParameters.h"

class ExplosionParametersReader
{
public:
	ExplosionParametersReader(std::string filename, ExplosionParameters* explosionParameters);
	~ExplosionParametersReader();
	

private:
	void parseStream(std::istream &is);
	void parseLine(const std::string &line);

	ExplosionParameters* explosionParameters;
};
