#pragma once

#pragma warning (disable:4995)
#include <string>
#include <map>
#include "DXUT.h"
using namespace std;



class EffectManager
{
public:
	static EffectManager& Instance();
	~EffectManager();

	ID3D10Effect* GetEffect(string filename, ID3D10Device* device);
	void PrepareEffectWithMacros(string filename, ID3D10Device* device, D3D10_SHADER_MACRO *shader_Macros);


	void ReleaseAll();

private:
	EffectManager();

	ID3D10Effect* CreateEffectFromFile(string filename, ID3D10Device* device, D3D10_SHADER_MACRO *shader_Macros = NULL);
	map<string, ID3D10Effect*> effectMap;
};
