#pragma once
#include "DXUT.h"


#pragma warning (disable:4995)
#include <vector>
#include <list>
#include <string>
#include <exception>

#include "TextureStore.h"

using namespace std;

class TextureStore3D : public TextureStore
{
public:
	TextureStore3D(int width, int height, int depth, ID3D10Device* device, int numberOfTempsNeeded = 1);
	~TextureStore3D();

	virtual int AddTexture(string description, ID3D10Device* device);
	ID3D10Resource* GetStagingTexture(ID3D10Device* device);

private:	
	ID3D10Texture3D* stagingTexture;
	int depth;
};
