#pragma once

#include "GameComponent.h"
#include "DXUT.h"

class DrawableGameComponent : public GameComponent
{
public:
	DrawableGameComponent() : drawOrder(100) {}
	virtual ~DrawableGameComponent() {}

	virtual void Draw(ID3D10Device* device, double time, float elapsedTime) {}

	virtual bool LoadGeneralGraphicsContent(ID3D10Device* device, const DXGI_SURFACE_DESC *bufferSurfaceDesc) { return true; }
	virtual void ReleaseGeneralGraphicsContent() {}

	virtual void LoadBackBufferDependantGraphicsContent(ID3D10Device* device, IDXGISwapChain *swapChain, const DXGI_SURFACE_DESC* bufferSurfaceDesc) {}
	virtual void ReleaseBackBufferDependantGraphicsContent() {}

	virtual int GetDrawOrder() const;
	virtual void SetDrawOrder(int order);

	virtual void CleanUp();

private:
	int drawOrder;
};
