#include "stdafx.h"

#include "FpsComponent.h"

#pragma warning (disable:4995)
#include <sstream>
#include <iostream>
using namespace std;

FpsComponent::FpsComponent()
{
}

FpsComponent::~FpsComponent()
{
}


void FpsComponent::Draw(ID3D10Device* device, double time, float elapsedTime) 
{
	const int framesPerReport = 50;
	static int frameCount = 0;
	static float timeAtLastReport = (float) time;
	static float averageSum = 0.0;
	static int averageSumCount = 0;
	static int totalFrameCount = 0;
	totalFrameCount++;
	frameCount++;
	
	static bool hasReportedFps = false;
	

	//if (frameCount >= framesPerReport) {
//	if (time > 2 && !hasReportedFps) {
	if (frameCount == framesPerReport) {
		hasReportedFps = true;
		//float fps = (float) (framesPerReport / (time - timeAtLastReport));
		float fps = (float) (frameCount / (time - timeAtLastReport));
		averageSum += fps;
		averageSumCount++;
		timeAtLastReport = (float) time;
		frameCount = 0;

		stringstream str;
		str << "FPS: " << fps <<  " Avg: " << (averageSum/averageSumCount) << " (frame #" << totalFrameCount <<")"  << endl;
		string s = str.str();
		OutputDebugStringA(s.c_str());
		cout << s;
		
	}
	
}