#pragma once
#include "ReferencedObject.h"

class GameComponent : public virtual ReferencedObject
{
public:
	GameComponent() : updateOrder(100) {}
	virtual ~GameComponent() {}


	virtual void Initialize() {}
	virtual void Update(double time, float elapsedTime) {}

	virtual int GetUpdateOrder() const;
	virtual void SetUpdateOrder(int order);
	
	virtual bool IsActive() { return true; }

private:
	int updateOrder;
};
