#pragma once

#include "DXUT.h"

#pragma warning (disable:4995)
#include <vector>

class HlslTextureOperation
{
public:
	HlslTextureOperation();
	virtual ~HlslTextureOperation();

	void SetOutputTextureID(int id);
	void SetOutputTextureIDs(int id1, int id2);
	void SetOutputTextureIDs(int id1, int id2, int id3);
	void SetOutputTextureIDs(int id1, int id2, int id3, int id4);

	virtual void Execute(ID3D10Device* device) = 0;

protected:
	std::vector< std::pair<int,bool> > renderTargetInfo;
};
